Bio::Tools::Run::TribeMCL use Bio::Tools::Run::TribeMCL; use Bio::SearchIO; # 3 methods to input the blast results # straight forward raw blast output (NCBI or WU-BLAST) my @params = ('inputtype'=>'blastfile'); # OR # markov program format # protein_id1 protein_id2 evalue_magnitude evalue_factor # for example: # proteins ENSP00000257547 and ENSP00000261659 # with a blast score evalue of 1e-50 # and proteins O42187 and ENSP00000257547 # with a blast score evalue of 1e-119 # entry would be my @array = [[qw(ENSP00000257547 ENSP00000261659 1 50)], [qw(O42187 ENSP00000257547 1 119)]]; my @params = ('pairs'=>\@array,I=>'2.0'); # OR # pass in a searchio object # slowest of the 3 methods as it does more rigourous parsing # than required for us here my $sio = Bio::SearchIO->new(-format=>'blast', -file=>'blast.out'); my @params=('inputtype'=>'searchio',I=>'2.0'); # you can specify the path to the executable manually in the following way my @params=('inputtype'=>'blastfile',I=>'2.0', 'mcl'=>'/home/shawn/software/mcl-02-150/src/shmcl/mcl', 'matrix'=>'/home/shawn/software/mcl-02-150/src/contrib/tribe/tribe-matrix'); my $fact = Bio::Tools::Run::TribeMCL->new(@params); # OR $fact->matrix_executable('/home/shawn/software/mcl-02-150/src/contrib/tribe/tribe-matrix'); $fact->mcl_executable('/home/shawn/software/mcl-02-150/src/shmcl/mcl'); # to run my $fact = Bio::Tools::Run::TribeMCL->new(@params); # Run the program # returns an array reference to clusters where members are the ids # for example :2 clusters with 3 members per cluster: # $fam = [ [mem1 mem2 mem3],[mem1 mem2 mem3]] # pass in either the blastfile path/searchio obj/the array ref to scores my $fam = $fact->run($sio); # print out your clusters for (my $i = 0; $i <scalar(@{$fam}); $i++){ print "Cluster $i \t ".scalar(@{$fam->[$i]})." members\n"; foreach my $member (@{$fam->[$i]}){ print "\t$member\n"; } } TribeMCL is a method for clustering proteins into related groups, which are termed 'protein families'. This clustering is achieved by analysing similarity patterns between proteins in a given dataset, and using these patterns to assign proteins into related groups. In many cases, proteins in the same protein family will have similar functional properties. TribeMCL uses a novel clustering method (Markov Clustering or MCL) which solves problems which normally hinder protein sequence clustering. Reference: Enright A.J., Van Dongen S., Ouzounis C.A; Nucleic Acids Res. 30(7):1575-1584 (2002) You will need tribe-matrix (the program used to generate the matrix for input into mcl) and mcl (the clustering software) available at: http://www.ebi.ac.uk/research/cgg/tribe/ or http://micans.org/mcl/. Future Work in this module: Port the tribe-matrix program into perl so that we can enable have a SearchIO kinda module for reading and writing mcl data format

Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to one of the Bioperl mailing lists. Your participation is much appreciated. bioperl-l@bioperl.org - General discussion http://bio.perl.org/MailList.html - About the mailing lists

Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track the bugs and their resolution. Bug reports can be submitted via the web: http://bugzilla.bioperl.org/ Email shawnh@fugu-sg.org The rest of the documentation details each of the object methods. Internal methods are usually preceded with a "_".

mcl_executable
Title : mcl_executable Usage : $self->mcl_executable() Function: get set for path to mcl executable Returns : String or undef if not installed Args : [optional] string of path to executable [optional] boolean to warn on missing executable status

matrix_executable
Title : matrix_executable Usage : $self->matrix_executable() Function: get set for path to tribe-matrix executable Returns : String or undef if not installed Args : [optional] string of path to executable [optional] boolean to warn on missing executable status

run
Title : run Usage : $self->run() Function: runs the clustering Returns : Array Ref of clustered Ids Args :

_run_mcl
Title : _run_mcl Usage : $self->_run_mcl() Function: internal function for running the mcl program Returns : Array Ref of clustered Ids Args : Index_file name, matrix input file name

_run_matrix
Title : _run_matrix Usage : $self->_run_matrix() Function: internal function for running the tribe-matrix program Returns : index filepath and matrix file path Args : filepath of parsed ids and scores

_setup_input
Title : _setup_input Usage : $self->_setup_input() Function: internal function for running setting up the inputs needed for running mcl Returns : filepath of parsed ids and scores Args :

_get_from_hsp
Title : _get_from_hsp Usage : $self->_get_from_hsp() Function: internal function for getting blast scores from hsp Returns : array ref to ids and score [protein1 protein2 magnitude factor] Args : L<Bio::Search::HSP::GenericHSP>

_get_from_searchio
Title : _get_from_searchio Usage : $self->_get_from_searchio() Function: internal function for parsing blast scores from searchio object Returns : array ref to ids and score [protein1 protein2 magnitude factor] Args : L<Bio::Tools::SearchIO>

_parse_blastfile
Title : _parse_blastfile Usage : $self->_parse_blastfile() Function: internal function for quickly parsing blast evalue scores from raw blast output file Returns : array ref to ids and score [protein1 protein2 magnitude factor] Args : file path

_parse_mcl
Title : _parse_mcl Usage : $self->_parse_mcl() Function: internal function for quickly parsing mcl output and generating the array of clusters Returns : Array Ref of clustered Ids Args : index file path, mcl output file path